function [avg,seg]=snrseg(s,sr,L);
%SNRSEG	[avg seg] = snrseg(s,sr,L)
%
%	Calcula a SNRseg em dB com segmentos de
%		  L amostras
%	para a reconstrucao
%		sr
%	do sinal
%		s

%
% Criado por Miguel Arjona Ramrez em 26 de setembro de 1996.
%
l=10/log(10);
s=s(:); sr=sr(:);
N=min([length(s) length(sr)]);
K=floor(N/L);
s=reshape(s(1:K*L),L,K);	% segmenta
sr=reshape(sr(1:K*L),L,K);	% segmenta
%
m=max(abs(s));
i=find(m~=0);			% segmentos no identicamente nulos
s=s(:,i);
sr=sr(:,i);
%
sq=l*log(sum(s.^2));		% energias dos segmentos do sinal
sqm=max(sq);
j=find(sq>sqm-50);		% critrio de Jos Sindi Yamamoto
s=s(:,j);
sq=sq(:,j);
sr=sr(:,j);
%
e=s-sr;				% sinal de erro
eq=l*log(sum(e.^2));		% energias dos segmentos do sinal de erro
%
seg=sq-eq;
avg=mean(seg);
